import { ConsoleMethods } from '../../../firstload/src/types/client';
import { ConsoleMessage, ErrorMessage } from '../../../frontend/src/util/shared-types';
import { HighlightClassOptions } from '../index';
import { RequestResponsePair } from './network-listener/utils/models';
export declare class FirstLoadListeners {
    disableConsoleRecording: boolean;
    consoleMethodsToRecord: ConsoleMethods[];
    listeners: (() => void)[];
    errors: ErrorMessage[];
    messages: ConsoleMessage[];
    options: HighlightClassOptions;
    hasNetworkRecording: boolean | undefined;
    _backendUrl: string;
    disableNetworkRecording: boolean;
    enableRecordingNetworkContents: boolean;
    xhrNetworkContents: RequestResponsePair[];
    fetchNetworkContents: RequestResponsePair[];
    tracingOrigins: boolean | (string | RegExp)[];
    networkHeadersToRedact: string[];
    networkBodyKeysToRecord: string[] | undefined;
    networkHeaderKeysToRecord: string[] | undefined;
    urlBlocklist: string[];
    constructor(options: HighlightClassOptions);
    isListening(): boolean;
    startListening(): void;
    stopListening(): void;
    static setupNetworkListener(sThis: FirstLoadListeners, options: HighlightClassOptions): void;
    static getRecordedNetworkResources(sThis: FirstLoadListeners, recordingStartTime: number): Array<any>;
    static clearRecordedNetworkResources(sThis: FirstLoadListeners): void;
}
