import { NetworkRecordingOptions } from '../../../../firstload/src/types/client';
import { RequestResponsePair } from './utils/models';
export declare type NetworkListenerCallback = (requestResponsePair: RequestResponsePair) => void;
declare type NetworkListenerArguments = {
    xhrCallback: NetworkListenerCallback;
    fetchCallback: NetworkListenerCallback;
    headersToRedact: string[];
    backendUrl: string;
    tracingOrigins: boolean | (string | RegExp)[];
    urlBlocklist: string[];
    sessionSecureID: string;
} & Pick<NetworkRecordingOptions, 'bodyKeysToRecord' | 'headerKeysToRecord'>;
export declare const NetworkListener: ({ xhrCallback, fetchCallback, headersToRedact, backendUrl, tracingOrigins, urlBlocklist, sessionSecureID, bodyKeysToRecord, headerKeysToRecord, }: NetworkListenerArguments) => () => void;
export {};
